package{

//--------------------------------------------------------------------//
// daXvC
  public class PolyharmonicSpline extends Rbf{

// 
    public var order:int;

//--------------------------------------------------------------------//
    public function PolyharmonicSpline(order:int):void{
      this.order=order;
    }

//--------------------------------------------------------------------//
// ֐̒lvZ
// i - _̃CfbNX
// x - _̍Wi[z
    public override function basisFunction(i:int,x:Vector.<Number>):Number{
      var r:Number=disanceSq(i,x);
      if(order%2==0){
      	if(r==0.0){
      	  return atRZero();
      	}
      	else{
      	  r=Math.sqrt(r);
      	  return Math.pow(r,order)*Math.log(r);
      	}
      }
      else{
      	return Math.pow(Math.sqrt(r),order);
      }
    }

//--------------------------------------------------------------------//
// a0ł̊֐̒lԂ
    public override function atRZero():Number{
      return 0.0;
    }
  }
}
