package{
  import figure.Cube3D;
  import figure.Point3D;

//--------------------------------------------------------------------//
// ˊ֐ԃf[^f
  public class RbfDataModel{

// _Ԃ̍ŏ
    public static const MIN_DISTANCE_SQ:Number=1.0e-6;

// _Xg
    public var points:Vector.<Point3D>;

// iq_xW̕ 
    public var nx:int;

// iq_yW̕
    public var ny:int;

// iq_i[z
    public var grid:Array;

// iq͈
    public var range:Cube3D;

//--------------------------------------------------------------------//
    public function RbfDataModel():void{
      points=new Vector.<Point3D>();
      nx=-1;
      ny=-1;
      grid=new Array();
      range=new Cube3D();
    }

//--------------------------------------------------------------------//
// _ǉ
    public function addPoint(p:Point3D):void{
      for(var i:int=0;i<points.length;i++){
      	var dx:Number=points[i].x-p.x;
      	var dy:Number=points[i].y-p.y;
      	if((dx*dx+dy*dy)<=MIN_DISTANCE_SQ){
      	  return;				// dȂ_͉Ȃ
      	}
      }
      points.push(p);
    }

//--------------------------------------------------------------------//
// f[^
    public function clear():void{
      points.length=0;
      nx=-1;
      ny=-1;
      grid.length=0;
      range.setBounds(0.0,0.0,0.0,0.0,0.0,0.0);
    }

//--------------------------------------------------------------------//
// iq_쐬
// rbf ˊ֐
// nx - iq_ x W̕
// x0 - iq_ x W̍ŏl
// x1 - iq_ x W̍ől
// ny - iq_ y W̕
// y0 - iq_ y W̍ŏl
// y1 - iq_ y W̍ől
    public function createGrid(rbf:Rbf,nx:int,x0:Number,x1:Number,
      	      	      	       ny:int,y0:Number,y1:Number):void{
      this.nx=nx;
      this.ny=ny;
      var xx:Array=new Array();
      var zz:Vector.<Number>=new Vector.<Number>(points.length,true);
      for(var i:int=0;i<points.length;i++){
      	xx[i]=new Vector.<Number>(2,true);
      	xx[i][0]=points[i].x;
      	xx[i][1]=points[i].y;
      	zz[i]=points[i].z;
      }
      rbf.setBasePoint(points.length,2,xx);
      rbf.setWeight(zz);

      var dx:Number=(x1-x0)/Number(nx);
      var dy:Number=(y1-y0)/Number(ny);
      var zMin:Number=0.0;
      var zMax:Number=0.0;
      grid=new Array();
      for(i=0;i<=nx;i++){
      	var x:Number=x0+dx*Number(i);
      	grid[i]=new Vector.<Point3D>(ny+1,true);
      	for(var j:int=0;j<=ny;j++){
      	  var y:Number=y0+dy*Number(j);
      	  var z:Number=rbf.getValue(Vector.<Number>([x,y]));
      	  grid[i][j]=new Point3D(x,y,z);
      	  if((i==0) && (j==0)){
      	    zMin=z;
      	    zMax=z;
      	  }
      	  else{
      	    zMin=Math.min(zMin,z);
      	    zMax=Math.max(zMax,z);
      	  }
      	}
      }
      range.setBounds(x0,y0,zMin,x1-x0,y1-y0,zMax-zMin);
    }
  }
}
