package{
  import figure.DefaultMatrixSolver;

//--------------------------------------------------------------------//
// ˊ֐
  public class Rbf{

// _̐
    public var dataCount:int;

// ϐ̐
    public var varCount:int;

// _Wi[z
    public var c:Array;

// d݌Wi[z
    public var w:Vector.<Number>;

//--------------------------------------------------------------------//
    public function Rbf():void{
      dataCount=0;
      varCount=0;
    }

//--------------------------------------------------------------------//
// ֐̒lvZ
// i - _̃CfbNX
// x - _̍Wi[z
    public function basisFunction(i:int,x:Vector.<Number>):Number{
      return 0.0;
    }

//--------------------------------------------------------------------//
// a0ł̊֐̒lԂ
    public function atRZero():Number{
      return 0.0;
    }

//--------------------------------------------------------------------//
// _ݒ肷
// x - _Wi[z
    public function setBasePoint(dataCount:int,varCount:int,
      	      	      	      	 x:Array):void{
      this.dataCount=dataCount;
      this.varCount=varCount;
      c=new Array();
      for(var i:int=0;i<dataCount;i++){
      	c[i]=new Vector.<Number>(varCount,true);
      	for(var j:int=0;j<varCount;j++){
      	  c[i][j]=x[i][j];
      	}
      }
      w=new Vector.<Number>(dataCount+varCount+1,true);
    }

//--------------------------------------------------------------------//
// d݌Wݒ肷
// f _ł̊֐li[z
    public function setWeight(f:Vector.<Number>):void{
      var size:int=dataCount+varCount+1;
      var a:DefaultMatrixSolver=new DefaultMatrixSolver(size);
      var b:Vector.<Number>=new Vector.<Number>(size,true);
      for(var i:int=0;i<dataCount;i++){
      	a.set(i,i,atRZero());
      	for(var j:int=i+1;j<dataCount;j++){
      	  var d:Number=basisFunction(j,c[i]);
      	  a.set(i,j,d);
      	  a.set(j,i,d);
      	}
      	a.set(i,dataCount,1.0);
      	a.set(dataCount,i,1.0);
      	for(j=0;j<varCount;j++){
      	  a.set(i,dataCount+1+j,c[i][j]);
      	  a.set(dataCount+1+j,i,c[i][j]);
      	}
      	b[i]=f[i];
      }
      b[dataCount]=0.0;
      for(j=0;j<varCount;j++){
      	b[dataCount+1+j]=0.0;
      }
      w=a.solveByLUNoPreserv(b,1.0E-8);
    }

//--------------------------------------------------------------------//
// ֐lԂ
// x - _̍Wi[z
    public function getValue(x:Vector.<Number>):Number{
      var s:Number=0.0;
      for(var i:int=0;i<dataCount;i++){
      	s+=w[i]*basisFunction(i,x);
      }
      s+=w[dataCount];
      for(var j:int=0;j<varCount;j++){
      	s+=w[dataCount+1+j]*x[j];
      }
      return s;
    }

//--------------------------------------------------------------------//
// _̋̂QԂ
// i - _̃CfbNX
// x - _̍Wi[z
    protected function disanceSq(i:int,x:Vector.<Number>):Number{
      var r2:Number=0.0;
      for(var j:int=0;j<varCount;j++){
      	r2+=(x[j]-c[i][j])*(x[j]-c[i][j]);
      }
      return r2;
    }
  }
}
